package com.hai.dao;

import com.hai.entity.OutRechargeOrder;
import com.hai.entity.OutRechargeOrderExample.Criteria;
import com.hai.entity.OutRechargeOrderExample.Criterion;
import com.hai.entity.OutRechargeOrderExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class OutRechargeOrderSqlProvider {

    public String countByExample(OutRechargeOrderExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("out_recharge_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(OutRechargeOrderExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("out_recharge_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(OutRechargeOrder record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("out_recharge_order");
        
        if (record.getRechargePrice() != null) {
            sql.VALUES("recharge_price", "#{rechargePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getOperatorType() != null) {
            sql.VALUES("operator_type", "#{operatorType,jdbcType=INTEGER}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeType() != null) {
            sql.VALUES("recharge_type", "#{rechargeType,jdbcType=INTEGER}");
        }
        
        if (record.getMemDiscountId() != null) {
            sql.VALUES("mem_discount_id", "#{memDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getMemDiscountName() != null) {
            sql.VALUES("mem_discount_name", "#{memDiscountName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.VALUES("user_name", "#{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserPhone() != null) {
            sql.VALUES("user_phone", "#{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsId() != null) {
            sql.VALUES("goods_id", "#{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getRechargeContent() != null) {
            sql.VALUES("recharge_content", "#{rechargeContent,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.VALUES("pay_type", "#{payType,jdbcType=INTEGER}");
        }
        
        if (record.getLaborUnionCard() != null) {
            sql.VALUES("labor_union_card", "#{laborUnionCard,jdbcType=VARCHAR}");
        }
        
        if (record.getIntegralNum() != null) {
            sql.VALUES("integral_num", "#{integralNum,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountDeductionPrice() != null) {
            sql.VALUES("discount_deduction_price", "#{discountDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDeductionPrice() != null) {
            sql.VALUES("integral_deduction_price", "#{integralDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayPrice() != null) {
            sql.VALUES("pay_price", "#{payPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.VALUES("pay_real_price", "#{payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.VALUES("pay_serial_no", "#{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTimed() != null) {
            sql.VALUES("create_timed", "#{createTimed,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.VALUES("pay_time", "#{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.VALUES("cancel_time", "#{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOutRefundNo() != null) {
            sql.VALUES("out_refund_no", "#{outRefundNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderPrice() != null) {
            sql.VALUES("order_price", "#{orderPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundTime() != null) {
            sql.VALUES("refund_time", "#{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getTpRefundOrderNo() != null) {
            sql.VALUES("tp_refund_order_no", "#{tpRefundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundId() != null) {
            sql.VALUES("refund_id", "#{refundId,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundFee() != null) {
            sql.VALUES("refund_fee", "#{refundFee,jdbcType=DECIMAL}");
        }
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getPayStatus() != null) {
            sql.VALUES("pay_status", "#{payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getMerchId() != null) {
            sql.VALUES("merch_id", "#{merchId,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeStatus() != null) {
            sql.VALUES("recharge_status", "#{rechargeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(OutRechargeOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("recharge_price");
        sql.SELECT("`type`");
        sql.SELECT("operator_name");
        sql.SELECT("operator_type");
        sql.SELECT("order_no");
        sql.SELECT("recharge_type");
        sql.SELECT("mem_discount_id");
        sql.SELECT("mem_discount_name");
        sql.SELECT("user_id");
        sql.SELECT("user_name");
        sql.SELECT("user_phone");
        sql.SELECT("goods_id");
        sql.SELECT("recharge_content");
        sql.SELECT("pay_type");
        sql.SELECT("labor_union_card");
        sql.SELECT("integral_num");
        sql.SELECT("discount_deduction_price");
        sql.SELECT("integral_deduction_price");
        sql.SELECT("pay_price");
        sql.SELECT("pay_real_price");
        sql.SELECT("pay_serial_no");
        sql.SELECT("create_timed");
        sql.SELECT("pay_time");
        sql.SELECT("cancel_time");
        sql.SELECT("finish_time");
        sql.SELECT("out_refund_no");
        sql.SELECT("order_price");
        sql.SELECT("refund_time");
        sql.SELECT("tp_refund_order_no");
        sql.SELECT("refund_id");
        sql.SELECT("refund_fee");
        sql.SELECT("company_id");
        sql.SELECT("pay_status");
        sql.SELECT("merch_id");
        sql.SELECT("recharge_status");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("out_recharge_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        OutRechargeOrder record = (OutRechargeOrder) parameter.get("record");
        OutRechargeOrderExample example = (OutRechargeOrderExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("out_recharge_order");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getRechargePrice() != null) {
            sql.SET("recharge_price = #{record.rechargePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getOperatorType() != null) {
            sql.SET("operator_type = #{record.operatorType,jdbcType=INTEGER}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeType() != null) {
            sql.SET("recharge_type = #{record.rechargeType,jdbcType=INTEGER}");
        }
        
        if (record.getMemDiscountId() != null) {
            sql.SET("mem_discount_id = #{record.memDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getMemDiscountName() != null) {
            sql.SET("mem_discount_name = #{record.memDiscountName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getRechargeContent() != null) {
            sql.SET("recharge_content = #{record.rechargeContent,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        }
        
        if (record.getLaborUnionCard() != null) {
            sql.SET("labor_union_card = #{record.laborUnionCard,jdbcType=VARCHAR}");
        }
        
        if (record.getIntegralNum() != null) {
            sql.SET("integral_num = #{record.integralNum,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountDeductionPrice() != null) {
            sql.SET("discount_deduction_price = #{record.discountDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDeductionPrice() != null) {
            sql.SET("integral_deduction_price = #{record.integralDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayPrice() != null) {
            sql.SET("pay_price = #{record.payPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.SET("pay_real_price = #{record.payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTimed() != null) {
            sql.SET("create_timed = #{record.createTimed,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOutRefundNo() != null) {
            sql.SET("out_refund_no = #{record.outRefundNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderPrice() != null) {
            sql.SET("order_price = #{record.orderPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getTpRefundOrderNo() != null) {
            sql.SET("tp_refund_order_no = #{record.tpRefundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundId() != null) {
            sql.SET("refund_id = #{record.refundId,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundFee() != null) {
            sql.SET("refund_fee = #{record.refundFee,jdbcType=DECIMAL}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getPayStatus() != null) {
            sql.SET("pay_status = #{record.payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getMerchId() != null) {
            sql.SET("merch_id = #{record.merchId,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeStatus() != null) {
            sql.SET("recharge_status = #{record.rechargeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("out_recharge_order");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("recharge_price = #{record.rechargePrice,jdbcType=DECIMAL}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("operator_type = #{record.operatorType,jdbcType=INTEGER}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("recharge_type = #{record.rechargeType,jdbcType=INTEGER}");
        sql.SET("mem_discount_id = #{record.memDiscountId,jdbcType=BIGINT}");
        sql.SET("mem_discount_name = #{record.memDiscountName,jdbcType=VARCHAR}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        sql.SET("recharge_content = #{record.rechargeContent,jdbcType=VARCHAR}");
        sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        sql.SET("labor_union_card = #{record.laborUnionCard,jdbcType=VARCHAR}");
        sql.SET("integral_num = #{record.integralNum,jdbcType=DECIMAL}");
        sql.SET("discount_deduction_price = #{record.discountDeductionPrice,jdbcType=DECIMAL}");
        sql.SET("integral_deduction_price = #{record.integralDeductionPrice,jdbcType=DECIMAL}");
        sql.SET("pay_price = #{record.payPrice,jdbcType=DECIMAL}");
        sql.SET("pay_real_price = #{record.payRealPrice,jdbcType=DECIMAL}");
        sql.SET("pay_serial_no = #{record.paySerialNo,jdbcType=VARCHAR}");
        sql.SET("create_timed = #{record.createTimed,jdbcType=TIMESTAMP}");
        sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("out_refund_no = #{record.outRefundNo,jdbcType=VARCHAR}");
        sql.SET("order_price = #{record.orderPrice,jdbcType=DECIMAL}");
        sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        sql.SET("tp_refund_order_no = #{record.tpRefundOrderNo,jdbcType=VARCHAR}");
        sql.SET("refund_id = #{record.refundId,jdbcType=VARCHAR}");
        sql.SET("refund_fee = #{record.refundFee,jdbcType=DECIMAL}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("pay_status = #{record.payStatus,jdbcType=INTEGER}");
        sql.SET("merch_id = #{record.merchId,jdbcType=VARCHAR}");
        sql.SET("recharge_status = #{record.rechargeStatus,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        OutRechargeOrderExample example = (OutRechargeOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(OutRechargeOrder record) {
        SQL sql = new SQL();
        sql.UPDATE("out_recharge_order");
        
        if (record.getRechargePrice() != null) {
            sql.SET("recharge_price = #{rechargePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getOperatorType() != null) {
            sql.SET("operator_type = #{operatorType,jdbcType=INTEGER}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeType() != null) {
            sql.SET("recharge_type = #{rechargeType,jdbcType=INTEGER}");
        }
        
        if (record.getMemDiscountId() != null) {
            sql.SET("mem_discount_id = #{memDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getMemDiscountName() != null) {
            sql.SET("mem_discount_name = #{memDiscountName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getRechargeContent() != null) {
            sql.SET("recharge_content = #{rechargeContent,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{payType,jdbcType=INTEGER}");
        }
        
        if (record.getLaborUnionCard() != null) {
            sql.SET("labor_union_card = #{laborUnionCard,jdbcType=VARCHAR}");
        }
        
        if (record.getIntegralNum() != null) {
            sql.SET("integral_num = #{integralNum,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountDeductionPrice() != null) {
            sql.SET("discount_deduction_price = #{discountDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDeductionPrice() != null) {
            sql.SET("integral_deduction_price = #{integralDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayPrice() != null) {
            sql.SET("pay_price = #{payPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayRealPrice() != null) {
            sql.SET("pay_real_price = #{payRealPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPaySerialNo() != null) {
            sql.SET("pay_serial_no = #{paySerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTimed() != null) {
            sql.SET("create_timed = #{createTimed,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOutRefundNo() != null) {
            sql.SET("out_refund_no = #{outRefundNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderPrice() != null) {
            sql.SET("order_price = #{orderPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getTpRefundOrderNo() != null) {
            sql.SET("tp_refund_order_no = #{tpRefundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundId() != null) {
            sql.SET("refund_id = #{refundId,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundFee() != null) {
            sql.SET("refund_fee = #{refundFee,jdbcType=DECIMAL}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getPayStatus() != null) {
            sql.SET("pay_status = #{payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getMerchId() != null) {
            sql.SET("merch_id = #{merchId,jdbcType=VARCHAR}");
        }
        
        if (record.getRechargeStatus() != null) {
            sql.SET("recharge_status = #{rechargeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, OutRechargeOrderExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}